//+------------------------------------------------------------------+
//|                                                          Mix.mq4 |
//|                                                    karceWZROKIEM |
//|                                            http://www.kampno.pl/ |
//+------------------------------------------------------------------+
#property copyright "karceWZROKIEM"
#property link      "http://www.kampno.pl/"

#property indicator_separate_window

#property indicator_buffers 5
#property indicator_color1  Black
#property indicator_color2  Red
#property indicator_color3  Silver
#property indicator_color4  Blue
#property indicator_style4  STYLE_DASH
#property indicator_color5  Blue
#property indicator_level1    80
#property indicator_level2   -80
#property indicator_maximum  125
#property indicator_minimum -125

//---- input parameters
extern string TimeFrame   = "Current time frame";
extern string ________________01="List of MAs, eg form fiobo: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597";
extern string listMA="1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233";
extern string ________________02="MA to check SORT DEGREE";
extern int MAcheck=8;
extern string ________________10="MA sort type";
extern int MAmethod = 1;               // iMA moving average method:	
                                       //          0	Simple moving average,
                                       //          1	Exponential moving average,
                                       //          2	Smoothed moving average,
                                       //          3	Linear weighted moving average.

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
//---- buffers
double openOrder[];
double closeOrder[];
double Trend[];
double MAsortRel[];
double sortRel[];

int MAs[];
int cntMAs;
double maVal[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,openOrder);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,closeOrder); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,Trend);
   SetIndexBuffer(3,MAsortRel);
   SetIndexBuffer(4,sortRel);

   SetIndexLabel(0,"Open");
   SetIndexLabel(1,"Close");
   SetIndexLabel(2,"TrendDegree");
   SetIndexLabel(3,"MASortDegree");
   SetIndexLabel(4,"SortDegree");

         cntMAs = splitINT(MAs, listMA, ",");
         ArrayResize(maVal, cntMAs+1);
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
            timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+ "madnessMA("+MAcheck+" -> "+listMA+")");
   return(0);
}

//+------------------------------------------------------------------+
double Trend(int MA, int i)
{  
   //return (Close[i] - iMA(NULL,0,MA,0,MAmethod,PRICE_OPEN,i));
   return (Close[i] - maVal[MA]);
}
double sortRel(int MA1, int MA2, int i)
{  
   //return (iMA(NULL,0,MA2,0,MAmethod,PRICE_OPEN,i) - iMA(NULL,0,MA1,0,MAmethod,PRICE_OPEN,i));
   return (maVal[MA2] - maVal[MA1]);
}
////////////////////////////////////////////////////////////////////
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { openOrder[0] = limit+1; return(0); }


         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  openOrder[i]  = iCustom(NULL,timeFrame,indicatorFileName,"","",listMA,"",MAcheck,"",MAmethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
                  closeOrder[i] = iCustom(NULL,timeFrame,indicatorFileName,"","",listMA,"",MAcheck,"",MAmethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
                  Trend[i]      = iCustom(NULL,timeFrame,indicatorFileName,"","",listMA,"",MAcheck,"",MAmethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
                  MAsortRel[i]  = iCustom(NULL,timeFrame,indicatorFileName,"","",listMA,"",MAcheck,"",MAmethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
                  sortRel[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","",listMA,"",MAcheck,"",MAmethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
            }
            return(0);                
         }

   //
   //
   //
   //
   //
      
   for (i=limit; i>=0; i--)
   {
      setMAs(i);
      double TrendSUM      = 0;
      double TrendBUFF     = 0;
      double MAsortRelSUM  = 0;
      double MAsortRelBUFF = 0;

      for(int ii=0; ii<cntMAs; ii++)
      {
         double tmp = sortRel(ii, cntMAs, i);
            if(MAs[ii] > MAcheck) 
               tmp = 1*tmp; else tmp = -1*tmp;
                  MAsortRelBUFF += tmp;
                  MAsortRelSUM  += MathAbs(tmp);
               tmp = Trend(ii, i);
                  TrendBUFF += tmp;
                  TrendSUM += MathAbs(tmp);
                  
            //
            //
            //
            //
            //
                              
            if(ii-1<cntMAs)
            {
               double sortRelSUM = 0; 
               double sortRelBUFF = 0;
               for(int iii=0; iii<cntMAs; iii++)
               if(ii!=iii)
               {
                  tmp          = sortRel(ii, iii, i);
                  sortRelBUFF += tmp;
                  sortRelSUM  += MathAbs(tmp);
               }
            }
      }
      if(TrendSUM>    0) Trend[i]     = 100 * TrendBUFF / TrendSUM;
      if(sortRelSUM>  0) sortRel[i]   = 100 * sortRelBUFF / sortRelSUM;
      if(MAsortRelSUM>0) MAsortRel[i] = 100 * MAsortRelBUFF / MAsortRelSUM;
      
      if( sortRel[i] < Trend[i] && sortRel[i] <= MAsortRel[i] && sortRel[i] < 0)       openOrder[i] = 110;
      else if( sortRel[i] > Trend[i] && sortRel[i] >= MAsortRel[i]  && sortRel[i] > 0) openOrder[i] = -110;
      else                                                                             openOrder[i] = EMPTY_VALUE;
      
      if( (Trend[i] < Trend[i+1]  && sortRel[i] < Trend[i] ) || openOrder[i] == -110 )     closeOrder[i] = 110;
      else if( (Trend[i] > Trend[i+1]  && sortRel[i] > Trend[i] ) || openOrder[i] == 110 ) closeOrder[i] = -110;
      else                                                                                 closeOrder[i] = EMPTY_VALUE;
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      if (closeOrder[whichBar] ==  110) doAlert(" sell signal");
      if (closeOrder[whichBar] == -110) doAlert(" buy signal");
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime  = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," madness MA "+doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"madness MA"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+

int splitINT(int& arr[], string str, string sym) 
{
  ArrayResize(arr, 0);
  string item;
  int pos, size;
  
  int len = StringLen(str);
  for (int i=0; i < len;) {
    pos = StringFind(str, sym, i);
    if (pos == -1) pos = len;
    
    item = StringSubstr(str, i, pos-i);
    item = StringTrimLeft(item);
    item = StringTrimRight(item);
    
    size = ArraySize(arr);
    ArrayResize(arr, size+1);
    arr[size] =  StrToInteger(item);
    
    i = pos+1;
  }
  return (ArraySize(arr));
}

void setMAs(int i)
{
   for(int index=0; index<cntMAs; index++)
   maVal[index] = iMA(NULL,0,MAs[index],0,MAmethod,PRICE_CLOSE,i);
   maVal[cntMAs] = iMA(NULL,0,MAcheck,0,MAmethod,PRICE_CLOSE,i);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}